#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySailingaChievementCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySailingaChievementCFG> M_ActivitySailingaChievementCFG::msSingleton(nullptr);

int M_ActivitySailingaChievementCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaChievementCFGData* M_ActivitySailingaChievementCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySailingaChievementCFGData>& M_ActivitySailingaChievementCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaChievementCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySailingaChievementCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaChievementCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mTaskTitle = element->Attribute("TaskTitle");
		data.mTaskDesc = element->Attribute("TaskDesc");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mAchievementItem = element->IntAttribute("AchievementItem");
		data.mAchievementCounts = element->IntAttribute("AchievementCounts");
		data.mAwardItemID = element->IntAttribute("AwardItemID");
		data.mAwardItemCounts = element->IntAttribute("AwardItemCounts");
		data.mGoType = element->IntAttribute("GoType");
		{
			const char* FindRand = element->Attribute("FindRand");
			std::vector<std::string> vecFindRand;
			boost::split(vecFindRand, FindRand, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFindRand.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFindRand[i].c_str(), &temp))
				{
					data.mFindRand.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		assert(mMapData.find(data.mId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySailingaChievementCFG::Load()
{
	Load("../Config/M_ActivitySailingaChievementCFG.xml");
}

M_ActivitySailingaChievementCFG* M_ActivitySailingaChievementCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaChievementCFG());
	}
	return msSingleton.get();
}
